import { NonEmptyArray } from 'fp-ts/lib/NonEmptyArray';
import { Option } from 'fp-ts/lib/Option';
export declare type Identifier = string;
export interface Type {
    name: Identifier;
    parameters: Array<Type>;
}
export interface Member {
    type: Type;
    name: Option<Identifier>;
}
export interface Constructor {
    name: Identifier;
    members: Array<Member>;
}
export interface Parameter {
    name: Identifier;
    constraint: Option<Type>;
}
export interface Introduction {
    name: Identifier;
    parameters: Array<Parameter>;
}
export interface Data {
    introduction: Introduction;
    constructors: NonEmptyArray<Constructor>;
}
export declare const type: (name: string, parameters?: Type[]) => Type;
export declare const member: (type: Type, name?: Option<string>) => Member;
export declare const constructor: (name: string, members?: Member[]) => Constructor;
export declare const parameter: (name: string, constraint?: Option<Type>) => Parameter;
export declare const introduction: (name: string, parameters?: Parameter[]) => Introduction;
export declare const data: (introduction: Introduction, head: Constructor, tail: Constructor[]) => Data;
