"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var NonEmptyArray_1 = require("fp-ts/lib/NonEmptyArray");
var Option_1 = require("fp-ts/lib/Option");
exports.type = function (name, parameters) {
    if (parameters === void 0) { parameters = []; }
    return ({
        name: name,
        parameters: parameters
    });
};
exports.member = function (type, name) {
    if (name === void 0) { name = Option_1.none; }
    return ({
        type: type,
        name: name
    });
};
exports.constructor = function (name, members) {
    if (members === void 0) { members = []; }
    return ({
        name: name,
        members: members
    });
};
exports.parameter = function (name, constraint) {
    if (constraint === void 0) { constraint = Option_1.none; }
    return ({
        name: name,
        constraint: constraint
    });
};
exports.introduction = function (name, parameters) {
    if (parameters === void 0) { parameters = []; }
    return ({
        name: name,
        parameters: parameters
    });
};
exports.data = function (introduction, head, tail) { return ({
    introduction: introduction,
    constructors: new NonEmptyArray_1.NonEmptyArray(head, tail)
}); };
